/********************************************************************************
********************************************************************************/

#include <QtGui>

#include "stlaunchdialog.h"

int csx ;
double stlat[21];  // latitude of predefined site
double stlng[21];  // longitude of predefined site

StLaunchDialog::StLaunchDialog()
{
        setObjectName(QString::fromUtf8("StLaunchDialog"));
        resize(503, 312);
        textLabel1 = new QLabel(this);
        textLabel1->setObjectName(QString::fromUtf8("textLabel1"));
        textLabel1->setGeometry(QRect(20, 10, 181, 23));
        textLabel1->setWordWrap(false);
        latEdit = new QLineEdit(this);
        latEdit->setObjectName(QString::fromUtf8("latEdit"));
        latEdit->setGeometry(QRect(240, 30, 91, 24));
        lngEdit = new QLineEdit(this);
        lngEdit->setObjectName(QString::fromUtf8("lngEdit"));
        lngEdit->setGeometry(QRect(240, 90, 91, 24));
        textLabel3 = new QLabel(this);
        textLabel3->setObjectName(QString::fromUtf8("textLabel3"));
        textLabel3->setGeometry(QRect(240, 10, 118, 21));
        textLabel3->setWordWrap(false);
        textLabel4 = new QLabel(this);
        textLabel4->setObjectName(QString::fromUtf8("textLabel4"));
        textLabel4->setGeometry(QRect(240, 70, 121, 21));
        textLabel4->setWordWrap(false);
        buttonGroup1 = new QGroupBox(this);
        buttonGroup1->setObjectName(QString::fromUtf8("buttonGroup1"));
        buttonGroup1->setGeometry(QRect(360, 10, 114, 81));
        // #### buttonGroup1->setOrientation(Qt::Vertical);
        southButton = new QRadioButton(buttonGroup1);
        southButton->setObjectName(QString::fromUtf8("southButton"));
        southButton->setGeometry(QRect(10, 50, 80, 21));
        northButton = new QRadioButton(buttonGroup1);
        northButton->setObjectName(QString::fromUtf8("northButton"));
        northButton->setGeometry(QRect(10, 20, 71, 21));
        textLabel5 = new QLabel(this);
        textLabel5->setObjectName(QString::fromUtf8("textLabel5"));
        textLabel5->setGeometry(QRect(240, 130, 101, 21));
        textLabel5->setWordWrap(false);
        mecoEdit = new QLineEdit(this);
        mecoEdit->setObjectName(QString::fromUtf8("mecoEdit"));
        mecoEdit->setGeometry(QRect(240, 150, 81, 24));
        okButton = new QPushButton(this);
        okButton->setObjectName(QString::fromUtf8("okButton"));
        okButton->setGeometry(QRect(410, 140, 71, 29));
        okButton->setDefault(true);
        cancelButton = new QPushButton(this);
        cancelButton->setObjectName(QString::fromUtf8("cancelButton"));
        cancelButton->setGeometry(QRect(410, 180, 71, 29));
        textLabel6 = new QLabel(this);
        textLabel6->setObjectName(QString::fromUtf8("textLabel6"));
        textLabel6->setGeometry(QRect(40, 280, 370, 20));
        textLabel6->setWordWrap(false);
        siteBox = new QComboBox(this);
        siteBox->setObjectName(QString::fromUtf8("siteBox"));
        siteBox->setGeometry(QRect(20, 30, 198, 29));
#ifndef QT_NO_SHORTCUT
        textLabel1->setBuddy(siteBox);
        textLabel3->setBuddy(latEdit);
        textLabel4->setBuddy(lngEdit);
        textLabel5->setBuddy(mecoEdit);
#endif // QT_NO_SHORTCUT
        QWidget::setTabOrder(okButton, cancelButton);
        QWidget::setTabOrder(cancelButton, siteBox);
        QWidget::setTabOrder(siteBox, latEdit);
        QWidget::setTabOrder(latEdit, lngEdit);
        QWidget::setTabOrder(lngEdit, mecoEdit);
        QWidget::setTabOrder(mecoEdit, northButton);
        QWidget::setTabOrder(northButton, southButton);

        connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
        connect(cancelButton, SIGNAL(pressed()), this, SLOT(reject()));
        connect(siteBox, SIGNAL(activated(int)), this, SLOT(siteSlot()));

        setWindowTitle(QApplication::translate("StLaunchDialog", "Launch Data", 0, QApplication::UnicodeUTF8));
        textLabel1->setText(QApplication::translate("StLaunchDialog", "Launch &Site:", 0, QApplication::UnicodeUTF8));
        textLabel3->setText(QApplication::translate("StLaunchDialog", "L&atitude (deg.):", 0, QApplication::UnicodeUTF8));
        textLabel4->setText(QApplication::translate("StLaunchDialog", "L&ongitude (deg.):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        buttonGroup1->setToolTip(QApplication::translate("StLaunchDialog", "Specify Launch Azimuth", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        buttonGroup1->setWhatsThis(QApplication::translate("StLaunchDialog", "To reach a given inclination a launch can proceed in a northerly or southerly direction. Often this direction will be fixed for a particular launch site due to safety restrictions.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        buttonGroup1->setTitle(QApplication::translate("StLaunchDialog", "Launch &Azimuth", 0, QApplication::UnicodeUTF8));
        southButton->setText(QApplication::translate("StLaunchDialog", "&South", 0, QApplication::UnicodeUTF8));
        southButton->setShortcut(QApplication::translate("StLaunchDialog", "Alt+S", 0, QApplication::UnicodeUTF8));
        northButton->setText(QApplication::translate("StLaunchDialog", "&North", 0, QApplication::UnicodeUTF8));
        northButton->setShortcut(QApplication::translate("StLaunchDialog", "Alt+N", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel5->setToolTip(QApplication::translate("StLaunchDialog", "Main engine cutoff time", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel5->setWhatsThis(QApplication::translate("StLaunchDialog", "This is typically the time used to initially reach orbit. Do not include extended burns of upper stages!", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel5->setText(QApplication::translate("StLaunchDialog", "&t cutoff (min):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        mecoEdit->setToolTip(QApplication::translate("StLaunchDialog", "Main engine cutoff time.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        mecoEdit->setWhatsThis(QApplication::translate("StLaunchDialog", "This is typically the time to initially reach orbit. Do not include the time for extended upper stage burns!", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        okButton->setText(QApplication::translate("StLaunchDialog", "&OK", 0, QApplication::UnicodeUTF8));
        okButton->setShortcut(QApplication::translate("StLaunchDialog", "Alt+O", 0, QApplication::UnicodeUTF8));
        cancelButton->setText(QApplication::translate("StLaunchDialog", "&Cancel", 0, QApplication::UnicodeUTF8));
        cancelButton->setShortcut(QApplication::translate("StLaunchDialog", "Alt+C", 0, QApplication::UnicodeUTF8));
        textLabel6->setText(QApplication::translate("StLaunchDialog", "Western longitudes and Southern latitudes negative", 0, QApplication::UnicodeUTF8));
};

void StLaunchDialog::siteSlot()
{
 QString s;
 
 csx = siteBox->currentIndex();
 if (csx > 0)
  {
   latEdit->setEnabled(false);
   lngEdit->setEnabled(false);
   s.setNum(stlat[csx]);
   latEdit->setText(s);
   s.setNum(stlng[csx]);
   lngEdit->setText(s); 
  }
 else
  {
   latEdit->setEnabled(true);
   lngEdit->setEnabled(true);
  };

}

void StLaunchDialog::setParams( int lsx, double lat, double lng, bool lsouth, double tmeco )
{
 QString s;
 
 s.setNum(lat);
 latEdit->setText(s);
 s.setNum(lng);
 lngEdit->setText(s);
 s.setNum(tmeco);
 mecoEdit->setText(s);
 if (lsouth) southButton->setChecked(true);
 else northButton->setChecked(true);
 csx = lsx;
 
 siteBox->insertItem(0, "User");    			
 siteBox->insertItem(1, "Kennedy Space Center");
 siteBox->insertItem(2, "Baikonur");
 siteBox->insertItem(3, "Kourou");
 siteBox->insertItem(4, "Vandenberg");
 siteBox->insertItem(5, "Plesetsk");
 siteBox->insertItem(6, "Svobodny");
 siteBox->insertItem(7, "Tanegashima");
 siteBox->insertItem(8, "Kagoshima");
 siteBox->insertItem(9, "Sriharikota");
 siteBox->insertItem(10, "Xichang");
 siteBox->insertItem(11, "Tai-yuan");
 siteBox->insertItem(12, "Jiuquan");
 siteBox->insertItem(13, "Wallops Island");
 siteBox->insertItem(14, "Israeli Launch Complex");
 siteBox->insertItem(15, "Alcantara");
 siteBox->insertItem(16, "Woomera");
 siteBox->insertItem(17, "Sea Launch");
 siteBox->insertItem(18, "Wallops Island");
 siteBox->insertItem(19, "Barents Sea");
 siteBox->insertItem(20, "Kwajalein");
 stlat[0] = 0; stlng[0] = 0;     // user
 stlat[1] = 28.6272; stlng[1] = -80.6208; // KSC
 stlat[2] = 45.9200; stlng[2] = 63.3423; // Baikonur
 stlat[3] = 5.237; stlng[3] = -52.775;  // Kourou
 stlat[4] = 34.7523; stlng[4] = -120.6155;  // Vandenberg
 stlat[5] = 62.855; stlng[5] = 40.867;      // Plesetsk
 stlat[6] = 51.35; stlng[6] = 128.133;	// Svobodny
 // stlat[6] = 48.4; stlng[6] = 45.8;	// Kapustin Yar
 stlat[7] = 30.38; stlng[7] = 130.97;	// Tanegashima
 stlat[8] = 31.23; stlng[8] = 131.08;	// Kagoshima
 stlat[9] = 13.576; stlng[9] = 80.293;	// Sriharikota
 stlat[10] = 28.25; stlng[10] = 102.02; // Xichang
 stlat[11] = 37.80; stlng[11] = 111.50; // Tai-yuan
 stlat[12] = 40.9581; stlng[12] = 100.2912; // Jiuquan
 stlat[13] = 37.85; stlng[13] = -75.47;	// Wallops Island
 stlat[14] = 31.52; stlng[14] = 34.45;	// Israeli Launch Complex
 stlat[15] = -2.4; stlng[15] = -44.4;   // Alcantara
 stlat[16] = -31.12; stlng[16] = 136.53;// Woomera
 stlat[17] = 0; stlng[17] = -154.0;     // Sea Launch
 stlat[18] = 37.84; stlng[18] = -75.48;  // Wallops Island
 stlat[19] = 69.5; stlng[19] = 34.2;  // Barents Sea
 stlat[20] = 8.99; stlng[20] = 167.72;  // Kwajalein
 siteBox->setCurrentIndex(csx);
}

void StLaunchDialog::getParams( int &lsx, double &lat, double &lng, bool &lsouth, double &tmeco )
{
 QString s;

  s=latEdit->text();
  lat = s.toDouble(); 
  s=lngEdit->text();
  lng = s.toDouble();
  s=mecoEdit->text();
  tmeco = s.toDouble();
  lsouth = southButton->isChecked();
  lsx = csx;
}
