/********************************************************************************
********************************************************************************/

#include <QtGui>
#include "storbdetdialog.h"
#include "satcalview.h"

StOrbDetDialog::StOrbDetDialog()
{
        setObjectName(QString::fromUtf8("StOrbDetDialog"));
        resize(421, 227);
        az1Edit = new QLineEdit(this);
        az1Edit->setObjectName(QString::fromUtf8("az1Edit"));
        az1Edit->setGeometry(QRect(20, 30, 91, 24));
        az1Label = new QLabel(this);
        az1Label->setObjectName(QString::fromUtf8("az1Label"));
        az1Label->setGeometry(QRect(20, 10, 121, 21));
        az1Label->setWordWrap(false);
        el1Label = new QLabel(this);
        el1Label->setObjectName(QString::fromUtf8("el1Label"));
        el1Label->setGeometry(QRect(150, 10, 111, 21));
        el1Label->setWordWrap(false);
        el1Edit = new QLineEdit(this);
        el1Edit->setObjectName(QString::fromUtf8("el1Edit"));
        el1Edit->setGeometry(QRect(150, 30, 91, 24));
        az2Label = new QLabel(this);
        az2Label->setObjectName(QString::fromUtf8("az2Label"));
        az2Label->setGeometry(QRect(20, 70, 121, 21));
        az2Label->setWordWrap(false);
        az2Edit = new QLineEdit(this);
        az2Edit->setObjectName(QString::fromUtf8("az2Edit"));
        az2Edit->setGeometry(QRect(20, 90, 91, 24));
        el2Label = new QLabel(this);
        el2Label->setObjectName(QString::fromUtf8("el2Label"));
        el2Label->setGeometry(QRect(150, 70, 111, 21));
        el2Label->setWordWrap(false);
        el2Edit = new QLineEdit(this);
        el2Edit->setObjectName(QString::fromUtf8("el2Edit"));
        el2Edit->setGeometry(QRect(150, 90, 91, 24));
        textLabel5 = new QLabel(this);
        textLabel5->setObjectName(QString::fromUtf8("textLabel5"));
        textLabel5->setGeometry(QRect(20, 130, 128, 21));
        textLabel5->setFrameShape(QFrame::NoFrame);
        textLabel5->setFrameShadow(QFrame::Plain);
        textLabel5->setWordWrap(false);
        deltmEdit = new QLineEdit(this);
        deltmEdit->setObjectName(QString::fromUtf8("deltmEdit"));
        deltmEdit->setGeometry(QRect(20, 150, 101, 24));
        obs2Box = new QCheckBox(this);
        obs2Box->setObjectName(QString::fromUtf8("obs2Box"));
        obs2Box->setGeometry(QRect(260, 90, 141, 21));
        obs1Box = new QCheckBox(this);
        obs1Box->setObjectName(QString::fromUtf8("obs1Box"));
        obs1Box->setGeometry(QRect(260, 30, 140, 21));
        cancelButton = new QPushButton(this);
        cancelButton->setObjectName(QString::fromUtf8("cancelButton"));
        cancelButton->setGeometry(QRect(320, 180, 81, 29));
        okButton = new QPushButton(this);
        okButton->setObjectName(QString::fromUtf8("okButton"));
        okButton->setGeometry(QRect(320, 140, 81, 29));
        okButton->setDefault(true);
        matchBox = new QCheckBox(this);
        matchBox->setObjectName(QString::fromUtf8("matchBox"));
        matchBox->setGeometry(QRect(150, 190, 161, 21));
        reverseButton = new QPushButton(this);
        reverseButton->setObjectName(QString::fromUtf8("reverseButton"));
        reverseButton->setGeometry(QRect(150, 130, 91, 21));
        picButton = new QPushButton(this);
        picButton->setObjectName(QString::fromUtf8("picButton"));
        picButton->setGeometry(QRect(150, 160, 91, 21));
#ifndef QT_NO_SHORTCUT
        az1Label->setBuddy(az1Edit);
        el1Label->setBuddy(el1Edit);
        az2Label->setBuddy(az2Edit);
        el2Label->setBuddy(el2Edit);
        textLabel5->setBuddy(deltmEdit);
#endif // QT_NO_SHORTCUT
        QWidget::setTabOrder(az1Edit, el1Edit);
        QWidget::setTabOrder(el1Edit, obs1Box);
        QWidget::setTabOrder(obs1Box, az2Edit);
        QWidget::setTabOrder(az2Edit, el2Edit);
        QWidget::setTabOrder(el2Edit, obs2Box);
        QWidget::setTabOrder(obs2Box, deltmEdit);
        QWidget::setTabOrder(deltmEdit, matchBox);
        QWidget::setTabOrder(matchBox, reverseButton);
        QWidget::setTabOrder(reverseButton, picButton);
        QWidget::setTabOrder(picButton, okButton);
        QWidget::setTabOrder(okButton, cancelButton);

        connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
        connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));
        connect(obs1Box, SIGNAL(toggled(bool)), this, SLOT(obs1Slot()));
        connect(obs2Box, SIGNAL(toggled(bool)), this, SLOT(obs2Slot()));
        connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));
        connect(reverseButton, SIGNAL(clicked()), this, SLOT(revSlot()));
        connect(picButton, SIGNAL(clicked()), this, SLOT(picSlot()));

        setWindowTitle(QApplication::translate("StOrbDetDialog", "Orbit Determination", 0, QApplication::UnicodeUTF8));
        az1Label->setText(QApplication::translate("StOrbDetDialog", "Azimuth &1 (deg):", 0, QApplication::UnicodeUTF8));
        el1Label->setText(QApplication::translate("StOrbDetDialog", "Elevation 1 (deg):", 0, QApplication::UnicodeUTF8));
        az2Label->setText(QApplication::translate("StOrbDetDialog", "Azimuth &2 (deg):", 0, QApplication::UnicodeUTF8));
        el2Label->setText(QApplication::translate("StOrbDetDialog", "Elevation 2 (deg):", 0, QApplication::UnicodeUTF8));
        textLabel5->setText(QApplication::translate("StOrbDetDialog", "&Delta Time (sec):", 0, QApplication::UnicodeUTF8));
        obs2Box->setText(QApplication::translate("StOrbDetDialog", "Obs2 as RA/Dec.", 0, QApplication::UnicodeUTF8));
        obs1Box->setText(QApplication::translate("StOrbDetDialog", "Obs1 as RA/Dec.", 0, QApplication::UnicodeUTF8));
        cancelButton->setText(QApplication::translate("StOrbDetDialog", "&Cancel", 0, QApplication::UnicodeUTF8));
        cancelButton->setShortcut(QApplication::translate("StOrbDetDialog", "Alt+C", 0, QApplication::UnicodeUTF8));
        okButton->setText(QApplication::translate("StOrbDetDialog", "&OK", 0, QApplication::UnicodeUTF8));
        okButton->setShortcut(QApplication::translate("StOrbDetDialog", "Alt+O", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        matchBox->setToolTip(QApplication::translate("StOrbDetDialog", "Try to match satellite.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        matchBox->setWhatsThis(QApplication::translate("StOrbDetDialog", "Checks the presently active TLE file for possible matches using the margins as set in the Match Satellite dialog.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        matchBox->setText(QApplication::translate("StOrbDetDialog", "&Match Satellite.", 0, QApplication::UnicodeUTF8));
        reverseButton->setToolTip(QApplication::translate("StOrbDetDialog", "Reverse Direction", 0, QApplication::UnicodeUTF8));
        reverseButton->setWhatsThis(QApplication::translate("StOrbDetDialog", "Interchanges the two positions to reverse the direction of movement.", 0, QApplication::UnicodeUTF8));
        reverseButton->setText(QApplication::translate("StOrbDetDialog", "&Reverse", 0, QApplication::UnicodeUTF8));
        picButton->setToolTip(QApplication::translate("StOrbDetDialog", "Use picture coordinates.", 0, QApplication::UnicodeUTF8));
        picButton->setWhatsThis(QApplication::translate("StOrbDetDialog", "The last two coordinates marked on the loaded sky picture will be used as observation points. ", 0, QApplication::UnicodeUTF8));
        picButton->setText(QApplication::translate("StOrbDetDialog", "&Picture", 0, QApplication::UnicodeUTF8));

};

void StOrbDetDialog::obs1Slot()
{
 if (obs1Box->isChecked()) 
  {
     az1Label->setText("R.A.&1 (HH.MMSS):");
     el1Label->setText("Dec.1 (DD.MMSS):");
  }
 else
  {
     az1Label->setText("Azimuth &1 (deg):");
     el1Label->setText("Elevation 1 (deg):");
  };
}

void StOrbDetDialog::obs2Slot()
{
 if (obs2Box->isChecked()) 
  {
     az2Label->setText("R.A.&2 (HH.MMSS):");
     el2Label->setText("Dec.2 (DD.MMSS):");
  }
 else
  {
     az2Label->setText("Azimuth &2 (deg):");
     el2Label->setText("Elevation 2 (deg):");
  };
}

void StOrbDetDialog::revSlot()
{
 QString s1, s2;
 bool obc1, obc2;
 
 s1=az1Edit->text();
 s2=az2Edit->text();
 az1Edit->setText(s2);
 az2Edit->setText(s1);
 s1=el1Edit->text();
 s2=el2Edit->text();
 el1Edit->setText(s2);
 el2Edit->setText(s1);

 obc1 = obs1Box->isChecked();
 obc2 = obs2Box->isChecked();
 obs1Box->setChecked(obc2);
 obs2Box->setChecked(obc1);
}

void StOrbDetDialog::picSlot()
{
 QString s;
 double az1, el1, az2, el2;

 vsGetPict(az1, el1, az2, el2);
 
 s.setNum(az1);
 az1Edit->setText(s);
 s.setNum(el1);
 el1Edit->setText(s);
 s.setNum(az2);
 az2Edit->setText(s);
 s.setNum(el2);
 el2Edit->setText(s);
 obs1Box->setChecked(true);
 obs2Box->setChecked(true);
 obs1Slot();
 obs2Slot();

}

void StOrbDetDialog::setParams( double az1, double el1, double az2, double el2, double deltm, bool az1flg, bool az2flg, bool odm, bool odp )
{
 QString s;
 
 s.setNum(az1);
 az1Edit->setText(s);
 s.setNum(el1);
 el1Edit->setText(s);
 s.setNum(az2);
 az2Edit->setText(s);
 s.setNum(el2);
 el2Edit->setText(s);
 s.setNum(deltm);
 deltmEdit->setText(s);
 obs1Box->setChecked(az1flg);
 obs2Box->setChecked(az2flg);
 obs1Slot();
 obs2Slot();
 matchBox->setChecked(odm);
 if (!odp)
  {
   picButton->setEnabled(false);
   picButton->hide();
  };
}

void StOrbDetDialog::getParams( double &az1, double &el1, double &az2, double &el2, double &deltm, bool &az1flg, bool &az2flg, bool &odm )
{
 QString s;

  s=az1Edit->text();
  az1 = s.toDouble();
  s=el1Edit->text();
  el1 = s.toDouble();
  s=az2Edit->text();
  az2 = s.toDouble();
  s=el2Edit->text();
  el2 = s.toDouble();
  s=deltmEdit->text();
  deltm = s.toDouble();
  az1flg = obs1Box->isChecked();
  az2flg = obs2Box->isChecked();
  odm = matchBox->isChecked();
}
