/********************************************************************************
********************************************************************************/

#ifndef STORBDETDIALOG_H
#define STORBDETDIALOG_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QDialog>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>

//QT_BEGIN_NAMESPACE

class StOrbDetDialog : public QDialog
{
  Q_OBJECT

public:
   StOrbDetDialog();

public slots:
    virtual void setParams( double az1, double el1, double az2, double el2, double deltm, bool az1flg, bool az2flg, bool odm, bool odp );
    virtual void getParams( double & az1, double & el1, double & az2, double & el2, double & deltm, bool & az1flg, bool & az2flg, bool & odm );
    virtual void obs1Slot();
    virtual void obs2Slot();
    virtual void revSlot();
    virtual void picSlot();

private:
    QLineEdit *az1Edit;
    QLabel *az1Label;
    QLabel *el1Label;
    QLineEdit *el1Edit;
    QLabel *az2Label;
    QLineEdit *az2Edit;
    QLabel *el2Label;
    QLineEdit *el2Edit;
    QLabel *textLabel5;
    QLineEdit *deltmEdit;
    QCheckBox *obs2Box;
    QCheckBox *obs1Box;
    QPushButton *cancelButton;
    QPushButton *okButton;
    QCheckBox *matchBox;
    QPushButton *reverseButton;
    QPushButton *picButton;

};
#endif // STORBDETDIALOG_H
