/********************************************************************************
********************************************************************************/

#include <QtGui>

#include "stselsatdialog.h"
#include "satcalview.h"

StSelSatDialog::StSelSatDialog()
{
        setObjectName(QString::fromUtf8("StSelSatDialog"));
        resize(600, 478);
        satinfEdit = new QTextEdit(this);
        satinfEdit->setObjectName(QString::fromUtf8("satinfEdit"));
        satinfEdit->setGeometry(QRect(190, 10, 391, 400));
        satinfEdit->setReadOnly(true);
        closeButton = new QPushButton(this);
        closeButton->setObjectName(QString::fromUtf8("closeButton"));
        closeButton->setGeometry(QRect(470, 430, 107, 29));
        closeButton->setAutoDefault(false);
        newButton = new QPushButton(this);
        newButton->setObjectName(QString::fromUtf8("newButton"));
        newButton->setGeometry(QRect(30, 380, 107, 29));
        findButton = new QPushButton(this);
        findButton->setObjectName(QString::fromUtf8("findButton"));
        findButton->setGeometry(QRect(30, 430, 107, 29));
        moreButton = new QPushButton(this);
        moreButton->setObjectName(QString::fromUtf8("moreButton"));
        moreButton->setGeometry(QRect(160, 430, 107, 29));
        selectButton = new QPushButton(this);
        selectButton->setObjectName(QString::fromUtf8("selectButton"));
        selectButton->setGeometry(QRect(300, 430, 107, 29));
        noradEdit = new QLineEdit(this);
        noradEdit->setObjectName(QString::fromUtf8("noradEdit"));
        noradEdit->setGeometry(QRect(11, 178, 104, 21));
        textLabel4 = new QLabel(this);
        textLabel4->setObjectName(QString::fromUtf8("textLabel4"));
        textLabel4->setGeometry(QRect(11, 162, 104, 16));
        textLabel4->setWordWrap(false);
        noradBox = new QCheckBox(this);
        noradBox->setObjectName(QString::fromUtf8("noradBox"));
        noradBox->setGeometry(QRect(11, 130, 150, 21));
        lowBox = new QCheckBox(this);
        lowBox->setObjectName(QString::fromUtf8("lowBox"));
        lowBox->setGeometry(QRect(11, 270, 150, 21));
        recentBox = new QCheckBox(this);
        recentBox->setObjectName(QString::fromUtf8("recentBox"));
        recentBox->setGeometry(QRect(11, 300, 150, 21));
        satnameEdit = new QLineEdit(this);
        satnameEdit->setObjectName(QString::fromUtf8("satnameEdit"));
        satnameEdit->setGeometry(QRect(11, 42, 158, 21));
        idsnBox = new QCheckBox(this);
        idsnBox->setObjectName(QString::fromUtf8("idsnBox"));
        idsnBox->setGeometry(QRect(11, 80, 150, 21));
        nameLabel = new QLabel(this);
        nameLabel->setObjectName(QString::fromUtf8("nameLabel"));
        nameLabel->setGeometry(QRect(11, 25, 158, 16));
        nameLabel->setWordWrap(false);
#ifndef QT_NO_SHORTCUT
        textLabel4->setBuddy(noradEdit);
        nameLabel->setBuddy(satnameEdit);
#endif // QT_NO_SHORTCUT
        QWidget::setTabOrder(satnameEdit, idsnBox);
        QWidget::setTabOrder(idsnBox, noradBox);
        QWidget::setTabOrder(noradBox, noradEdit);
        QWidget::setTabOrder(noradEdit, lowBox);
        QWidget::setTabOrder(lowBox, recentBox);
        QWidget::setTabOrder(recentBox, newButton);
        QWidget::setTabOrder(newButton, findButton);
        QWidget::setTabOrder(findButton, moreButton);
        QWidget::setTabOrder(moreButton, selectButton);
        QWidget::setTabOrder(selectButton, closeButton);
        QWidget::setTabOrder(closeButton, satinfEdit);

        connect(closeButton, SIGNAL(clicked()), this, SLOT(accept()));
        connect(newButton, SIGNAL(clicked()), this, SLOT(newsSlot()));
        connect(findButton, SIGNAL(clicked()), this, SLOT(findSlot()));
        connect(moreButton, SIGNAL(clicked()), this, SLOT(moreSlot()));
        connect(selectButton, SIGNAL(clicked()), this, SLOT(selectSlot()));
        connect(noradBox, SIGNAL(toggled(bool)), this, SLOT(noradSlot()));
        connect(idsnBox, SIGNAL(toggled(bool)), this, SLOT(idsnSlot()));
        connect(lowBox, SIGNAL(toggled(bool)), this, SLOT(lowSlot()));
        connect(recentBox, SIGNAL(toggled(bool)), this, SLOT(lowSlot()));

        setWindowTitle(QApplication::translate("StSelSatDialog", "Select Satellite", 0, QApplication::UnicodeUTF8));
        closeButton->setText(QApplication::translate("StSelSatDialog", "&Close", 0, QApplication::UnicodeUTF8));
        closeButton->setShortcut(QApplication::translate("StSelSatDialog", "Alt+C", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        newButton->setToolTip(QApplication::translate("StSelSatDialog", "Start a new satellite list.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        newButton->setWhatsThis(QApplication::translate("StSelSatDialog", "Delete all currently selected satellites and start a new list.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        newButton->setText(QApplication::translate("StSelSatDialog", "Ne&w Set", 0, QApplication::UnicodeUTF8));
        newButton->setShortcut(QApplication::translate("StSelSatDialog", "Alt+W", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        findButton->setToolTip(QApplication::translate("StSelSatDialog", "Start the search.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        findButton->setWhatsThis(QApplication::translate("StSelSatDialog", "Start the search for matching satellite names.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        findButton->setText(QApplication::translate("StSelSatDialog", "&Find", 0, QApplication::UnicodeUTF8));
        findButton->setShortcut(QApplication::translate("StSelSatDialog", "Alt+F", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        moreButton->setToolTip(QApplication::translate("StSelSatDialog", "More matches found.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        moreButton->setWhatsThis(QApplication::translate("StSelSatDialog", "Click here to display the next matches found.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        moreButton->setText(QApplication::translate("StSelSatDialog", "&More", 0, QApplication::UnicodeUTF8));
        moreButton->setShortcut(QApplication::translate("StSelSatDialog", "Alt+M", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        selectButton->setToolTip(QApplication::translate("StSelSatDialog", "Add satellite to list.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        selectButton->setWhatsThis(QApplication::translate("StSelSatDialog", "Add found satellite to the list.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        selectButton->setText(QApplication::translate("StSelSatDialog", "&Select", 0, QApplication::UnicodeUTF8));
        selectButton->setShortcut(QApplication::translate("StSelSatDialog", "Alt+S", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        noradEdit->setToolTip(QApplication::translate("StSelSatDialog", "NORAD catalogue number.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        noradEdit->setWhatsThis(QApplication::translate("StSelSatDialog", "Specify the NORAD catalogue number if you want to search for it. Normally you rather use the satellite name.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
#ifndef QT_NO_TOOLTIP
        textLabel4->setToolTip(QApplication::translate("StSelSatDialog", "NORAD catalogue number.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel4->setWhatsThis(QApplication::translate("StSelSatDialog", "Specifiy the satellite NORAD number if you want to. Normally you rather look for a name.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel4->setText(QApplication::translate("StSelSatDialog", "NORA&D#:", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        noradBox->setToolTip(QApplication::translate("StSelSatDialog", "NORAD catalogue number.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        noradBox->setWhatsThis(QApplication::translate("StSelSatDialog", "Two-line Elements of a satellite are identified by their NORAD number. You can search for this number rather than the satellite name.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        noradBox->setText(QApplication::translate("StSelSatDialog", "Select NO&RAD#", 0, QApplication::UnicodeUTF8));
        noradBox->setShortcut(QApplication::translate("StSelSatDialog", "Alt+R", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        lowBox->setToolTip(QApplication::translate("StSelSatDialog", "Low orbits only", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        lowBox->setWhatsThis(QApplication::translate("StSelSatDialog", "Only orbits < 250 km are considered.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        lowBox->setText(QApplication::translate("StSelSatDialog", "L&ow Orbits Only", 0, QApplication::UnicodeUTF8));
        lowBox->setShortcut(QApplication::translate("StSelSatDialog", "Alt+O", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        recentBox->setToolTip(QApplication::translate("StSelSatDialog", "Recent launches", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        recentBox->setWhatsThis(QApplication::translate("StSelSatDialog", "Only Satellites with < 100 revolutions are considered.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        recentBox->setText(QApplication::translate("StSelSatDialog", "R&ecent Launches", 0, QApplication::UnicodeUTF8));
        recentBox->setShortcut(QApplication::translate("StSelSatDialog", "Alt+E", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        satnameEdit->setToolTip(QApplication::translate("StSelSatDialog", "Name to search for. '*' if all satellites.  ", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        satnameEdit->setWhatsThis(QApplication::translate("StSelSatDialog", "Complete name or the beginning of it. Set to '*' to go through the list of all satellites.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
#ifndef QT_NO_TOOLTIP
        idsnBox->setToolTip(QApplication::translate("StSelSatDialog", "Select via International Launch Designator", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        idsnBox->setWhatsThis(QApplication::translate("StSelSatDialog", "The International Launch Designator must be entered fully, e.g. 1998-067A . If entering '*' all satellites will be selected.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        idsnBox->setText(QApplication::translate("StSelSatDialog", "Select Int.&Launch #", 0, QApplication::UnicodeUTF8));
        idsnBox->setShortcut(QApplication::translate("StSelSatDialog", "Alt+L", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        nameLabel->setToolTip(QApplication::translate("StSelSatDialog", "Name to search for. '*' for all satellites.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        nameLabel->setWhatsThis(QApplication::translate("StSelSatDialog", "Complete name or beginning of it. Set '*' to go through the complete list of all satellites..", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        nameLabel->setText(QApplication::translate("StSelSatDialog", "Satellite &Name:", 0, QApplication::UnicodeUTF8));
};

void StSelSatDialog::selectSlot()
{
  newButton->setEnabled(false);
  newButton->hide();
  selectButton->setEnabled(false);
  selectButton->hide();
  vsSatSel();
  dSatList();
}

void StSelSatDialog::moreSlot()
{
 QString s;
 int nrw, nrd, lwo, rlo;
 
 s = noradEdit->text();
 nrd = s.toInt();
 s = satnameEdit->text();
 nrw = 0;
 if(noradBox->isChecked()) nrw = 1;
 if(idsnBox->isChecked()) nrw = 2;
 if(lowBox->isChecked()) lwo = 1;
 else lwo = 0;
 if(recentBox->isChecked()) rlo = 1;
 else rlo = 0;
 vsReComp(s, nrd, nrw, 1, lwo, rlo);
 
 if(nrd == 0)
  {
   moreButton->setEnabled(false);
   moreButton->hide();
   selectButton->setEnabled(false);
   selectButton->hide();
  };   
 if(nrd == 1)
  {
   moreButton->setEnabled(false);
   moreButton->hide();
   selectButton->setEnabled(true);
   selectButton->show();
  };   
 if(nrd == 2)
  {
   moreButton->setEnabled(true);
   moreButton->show();
   selectButton->setEnabled(true);
   selectButton->show();
  };   
 
 dSatInfo(s); 
}

void StSelSatDialog::newsSlot()
{
    newButton->setEnabled(false);
    newButton->hide();
    vsResetSatList();
    dSatList();
}

void StSelSatDialog::findSlot()
{
 QString s;
 int nrw, nrd, lwo, rlo;
 
 s = noradEdit->text();
 nrd = s.toInt();
 s = satnameEdit->text();
 nrw = 0;
 if(noradBox->isChecked()) nrw = 1;
 if(idsnBox->isChecked()) nrw = 2;
 if(lowBox->isChecked()) lwo = 1;
 else lwo = 0;
 if(recentBox->isChecked()) rlo = 1;
 else rlo = 0;
 vsFindSat(s, nrd, nrw, lwo, rlo);
 
 if(nrd == 0)
  {
   moreButton->setEnabled(false);
   moreButton->hide();
   selectButton->setEnabled(false);
   selectButton->hide();
  };   
 if(nrd == 1)
  {
   moreButton->setEnabled(false);
   moreButton->hide();
   selectButton->setEnabled(true);
   selectButton->show();
  };   
 if(nrd == 2)
  {
   moreButton->setEnabled(true);
   moreButton->show();
   selectButton->setEnabled(true);
   selectButton->show();
  };   
 
 dSatInfo(s); 
}

void StSelSatDialog::idsnSlot()
{
 if (idsnBox->isChecked())
  {
   noradEdit->setEnabled(false);
   satnameEdit->setEnabled(true);
   if (noradBox->isChecked()) noradBox->setChecked(false);
   nameLabel->setText("Inter&national Launch#:");
  }
 else nameLabel->setText("Satellite &Name:");   
}

void StSelSatDialog::noradSlot()
{
 if (noradBox->isChecked())
  {
   noradEdit->setEnabled(true);
   satnameEdit->setEnabled(false);
   if (idsnBox->isChecked()) idsnBox->setChecked(false);
  }
 else
  {
   noradEdit->setEnabled(false);
   satnameEdit->setEnabled(true);
  };
}

void StSelSatDialog::lowSlot()
{
 int lwo, rlo;

 if(lowBox->isChecked()) lwo = 1;
 else lwo = 0;
 if(recentBox->isChecked()) rlo = 1;
 else rlo = 0;
 vsLowRecent(lwo, rlo);
 }

void StSelSatDialog::setParams()
{
 QString s1;
 int nsw, nrd, nsat, lwo, rlo;
 
 vsLastSat(s1, nsw, nrd, nsat, lwo, rlo);
 satnameEdit->setText(s1);
 satnameEdit->setFocus();
 s1.setNum(nrd);
 noradEdit->setText(s1);
 if (nsw == 1) noradBox->setChecked(true);
 if (nsw == 2) idsnBox->setChecked(true);
 if (nsat == 0) 
  {
    newButton->setEnabled(false);
    newButton->hide();
  }
 moreButton->setEnabled(false);
 moreButton->hide();
 selectButton->setEnabled(false);
 selectButton->hide();
 if (nsw == 2) idsnSlot();
 noradSlot();

 if (lwo == 1) lowBox->setChecked(true);
 if (rlo == 1) recentBox->setChecked(true);

 dSatList();
}

void StSelSatDialog::dSatInfo(const QString s1)
{
 QString s2;   
 int nsw, nrd, nsat, lwo, rlo;
 
 vsLastSat(s2, nsw, nrd, nsat, lwo, rlo);
 satnameEdit->setText(s2);
 s2.setNum(nrd);
 noradEdit->setText(s2);
 satinfEdit->clear();
 satinfEdit->setText(s1);
}

void StSelSatDialog::dSatList()
{
 QString s;
 
 s = vsSatList();
 satinfEdit->clear();
 satinfEdit->setText(s);
}
