/********************************************************************************
********************************************************************************/

#ifndef STSTATEDIALOG_H
#define STSTATEDIALOG_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QDialog>
#include <QtGui/QGroupBox>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>

//QT_BEGIN_NAMESPACE

class StStateDialog : public QDialog
{
  Q_OBJECT

public:
   StStateDialog();

public slots:
    virtual void setParams( bool nmflg, int year, double hour, double r0, double r1, double r2, double v0, double v1, double v2, double ecc );
    virtual void getParams( int & year, double & day, double & r0, double & r1, double & r2, double & v0, double & v1, double & v2 );
    virtual void timeSlot();
    virtual void refSlot();

private:
    QLabel *textLabel1;
    QLineEdit *yearEdit;
    QLabel *textLabel2_2;
    QLineEdit *dayEdit;
    QLabel *textLabel2;
    QLineEdit *r0Edit;
    QLabel *textLabel3;
    QLineEdit *r1Edit;
    QLabel *textLabel4;
    QLineEdit *r2Edit;
    QLabel *textLabel5;
    QLineEdit *v0Edit;
    QLabel *textLabel6;
    QLineEdit *v1Edit;
    QLabel *textLabel7;
    QLineEdit *v2Edit;
    QLineEdit *fb107Edit;
    QLineEdit *f107Edit;
    QLineEdit *kpEdit;
    QLineEdit *amEdit;
    QLineEdit *cdEdit;
    QLineEdit *crEdit;
    QPushButton *cancelButton;
    QPushButton *okButton;
    QLabel *fb107Label;
    QLabel *f107Label;
    QLabel *kpLabel;
    QLabel *amLabel;
    QLabel *cdLabel;
    QLabel *crLabel;
    QPushButton *timeButton;
    QGroupBox *coordGroup;
    QRadioButton *todButton;
    QRadioButton *j2000Button;
    QRadioButton *efixButton;
    QRadioButton *mdateButton;
    QCheckBox *cstateBox;

};

#endif // STSTATEDIALOG_H
