/********************************************************************************
********************************************************************************/

#ifndef STVISDIALOG_H
#define STVISDIALOG_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QDialog>
#include <QtGui/QGroupBox>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>

//QT_BEGIN_NAMESPACE

class StVisDialog : public QDialog
{
  Q_OBJECT

public:
   StVisDialog();

public slots:
    virtual void setParams( double sunel, double satel, double yrepoch, double occra, double occdec, int visflg, int moonflg );
    virtual void getParams( double & sunel, double & satel, double & yrepoch, double & occra, double & occdec, int & visflg, int & moonflg );
    virtual void showSlot();
    virtual void setParam2( int sunmplt, int occflg, int iridflg, int flarflg, int flarmod, int flaryst, bool eclflg, bool solflar, bool flrmgf, double flrmgx, bool cylflg );
    virtual void getParam2( int & sunmplt, int & occflg, int & iridflg, int & flarflg, int & flarmod, int & flaryst, bool & eclflg, bool & solflar, bool & flrmgf, double & flrmgx, bool & cylflg );
    virtual void flarSlot();
    virtual void occSlot();
    virtual void iridSlot();
    virtual void eclSlot();

private:
    QLabel *textLabel1;
    QLineEdit *sunelEdit;
    QLabel *textLabel2;
    QLineEdit *satelEdit;
    QCheckBox *visBox;
    QCheckBox *moonBox;
    QLabel *textLabel3;
    QLineEdit *epochEdit;
    QGroupBox *occGroup;
    QRadioButton *moonButton;
    QRadioButton *sunButton;
    QRadioButton *radecButton;
    QCheckBox *smplotBox;
    QCheckBox *occBox;
    QPushButton *cancelButton;
    QPushButton *okButton;
    QCheckBox *eclBox;
    QCheckBox *knownBox;
    QCheckBox *localBox;
    QCheckBox *solfBox;
    QLineEdit *yawEdit;
    QLabel *pitchLabel;
    QLineEdit *pitchEdit;
    QCheckBox *iridBox;
    QLineEdit *flrmxEdit;
    QCheckBox *flrmagBox;
    QLabel *flrmagLabel;
    QLabel *yawLabel;
    QCheckBox *flarBox;
    QCheckBox *ystBox;
    QCheckBox *cylBox;

};

#endif // STVISDIALOG_H
